#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

void main(int,char *[]);

extern unsigned stklen = 0x7FFF;

int auto_linefeed       = 0;
int out_count           = 0;
char out_buffer[2060];
int escape_mode         = 0;
int escape_char         = 0;

void my_bufferred_output(unsigned ch,FILE *fp)
{
    int khar;

    if (escape_mode) {
        if (ch == '|')
            khar = '^';
        else
            khar = (toupper(ch) & 0x00FF) - 64;
        out_buffer[out_count++] = khar;
        if (auto_linefeed) {
            if (khar == '\r')
                out_buffer[out_count++] = '\n';
        }
        escape_mode =
          escape_char = 0;
        goto BufferredExit;
    }
    if (ch == '^') {
        escape_mode = 1;
        escape_char = ch;
        return;
    }
    out_buffer[out_count++] = ch;
BufferredExit:
    if (out_count >= 2048) {
        fwrite(out_buffer,sizeof(char),out_count,fp);
        out_count = 0;
    }
}

void my_flush_bufferred_output(FILE *fp)
{
    if (escape_mode)
        out_buffer[out_count++] = escape_char;
    if (out_count)
        fwrite(out_buffer,sizeof(char),out_count,fp);
}

void main(int argc,char *argv[])
{
    FILE *fp_old;
    FILE *fp_new;
    int slen, j;
    unsigned char buffer[2050];
    char param[32];
    char fname_old[128];
    char fname_new[128];

    if (argc < 3) {
        printf(  "\nMonitor Mode Capture Convert Program");
        printf("\n\nERROR: Too few command line arguments.");
        printf("\n\n  Usage:  mmcvt  old_file  new_file  [/L]");
        printf("\n\n      Where: /L --- triggers auto-linefeed mode.  All CRs have");
        printf(  "\n                    automatically have a LF character added.");
        printf("\n\n");
        exit(1);
    }
    strcpy(fname_old,argv[1]);
    strcpy(fname_new,argv[2]);
    if (argc > 3) {
        strcpy(param,argv[3]);
        strupr(param);
        if ((param[0]=='-')||(param[0]=='/')) {
            if (param[1]=='L')
                auto_linefeed = 1;
        }
    }
    fp_old = fopen(fname_old,"rb");
    if (fp_old == NULL) {
        printf("\nCannot open %s.\n\n",fname_old);
        exit(1);
    }
    fp_new = fopen(fname_new,"wb");
    if (fp_new == NULL) {
        fclose(fp_old);
        printf("\nCannot create %s.\n\n",fname_new);
        exit(1);
    }
    do {
        slen = fread(buffer,sizeof(char),2048,fp_old);
        if (slen) {
            for (j=0; j<slen; j++)
                my_bufferred_output(buffer[j],fp_new);
        }
    } while (slen);
    my_flush_bufferred_output(fp_new);
    fclose(fp_old);
    fclose(fp_new);
    exit(0);
}
